#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

void fprintHead(FILE *f, int year, int month);
void fprintCalendar(FILE *f, int year, int month);
int getMaxDayMonth(int year, int month);
int getTotalDates(int year, int month);
int getDay(int dates);
int isLeap(int year);

int maxDayMonth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

//////////////////////////////////////////////////////////////////////
int main(void)
{
	int year, month;
	char fname[80];
	FILE *f;

	printf("⵵ Էϼ. (Է >> 2017)\n");
	scanf("%d", &year);
	printf("޷  ̸ Էϼ. (Է >> 2017.cal)\n");
	scanf("%s", fname);

	if ((f = fopen(fname, "w")) == NULL) {
		printf("  ʽϴ.");
		exit(1);
	}

	for (month = 1; month <= 12; month++) {
		fprintHead(f, year, month);
		fprintCalendar(f, year, month);
	}

	return 0;
}

void fprintHead(FILE *f, int year, int month)
{
	int i = 0;
	char *EDAY[] = { "SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT" };
	char *KDAY[] = { "", "", "ȭ", "", "", "", "" };

	printf("\n\t\t\t\t[%4d %2d]\n\n", year, month);
	fprintf(f, "\n\t\t\t\t[%4d %2d]\n\n", year, month);
	printf("\t");
	fprintf(f, "\t");
	for (; i < 7; i++)
	{
		printf("%8s", KDAY[i]);
		fprintf(f, "%8s", KDAY[i]);
	}
	printf("\n");
	fprintf(f, "\n");
}

//////////////////////////////////////////////////////////////////////
//  f ֿܼ year month ޷ 
void fprintCalendar(FILE *f, int year, int month)
{
	int date, day, i;
	int maxday, totalDates;

	totalDates = getTotalDates(year, month);
	totalDates++;
	day = getDay(totalDates);

	// day  Ͽ ƴϸ  κ 
	printf("\t");
	fprintf(f, "\t");
	if (day)
		for (i = 0; i < day; i++)
		{
			printf("%8s", " ");
			fprintf(f, "%8s", " ");
		}
	maxday = getMaxDayMonth(year, month);

	//1 ϱ 
	for (date = 1; date <= maxday; date++, totalDates++)
	{
		printf("%8d", date);
		fprintf(f, "%8d", date);
		if (getDay(totalDates) == 6)
		{
			printf("\n\t");
			fprintf(f, "\n\t");
		}
	}
	printf("\n\n");
	fprintf(f, "\n\n");
}

//////////////////////////////////////////////////////////////////////
//year month   ϼ 
int getTotalDates(int year, int month)
{
	int i;
	int totalDates = 0;

	for (i = 1; i < year; i++)
	{
		if (isLeap(i))
			//if ((i % 4 == 0) && (i % 100 != 0) || (i % 400 == 0))
			totalDates += 366;
		else
			totalDates += 365;
	}

	for (i = 1; i < month; i++)
	{
		totalDates += maxDayMonth[i - 1];
		if (i == 2)
			if (isLeap(year))
				totalDates++;
	}

	return totalDates;
}

//////////////////////////////////////////////////////////////////////
int getDay(int dates)
{
	return dates % 7;
}

//////////////////////////////////////////////////////////////////////
//year month ִ  
int getMaxDayMonth(int year, int month)
{
	int maxday = maxDayMonth[month - 1];
	if (month == 2)
	{
		if (isLeap(year))
			maxday = 29;
	}

	return maxday;
}

//////////////////////////////////////////////////////////////////////
//year ˻
int isLeap(int year)
{
	if ((year % 4 == 0) && (year % 100 != 0) || (year % 400 == 0))
		return 1;
	else
		return 0;
}

