#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

void gotoxy(int x, int y)
{
	COORD xy = { 0, 0 };
	xy.X = x; xy.Y = y; // X and Y coordinates
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), xy);
}

//This will set the forground color for printing in a console window.
void SetColor(int ForgC)
{
	WORD wColor;
	//We will need this handle to get the current background attribute
	HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFO csbi;

	//We use csbi for the wAttributes word.
	if (GetConsoleScreenBufferInfo(hStdOut, &csbi))
	{
		//Mask out all but the background attribute, and add in the forgournd color
		wColor = (csbi.wAttributes & 0xF0) + (ForgC & 0x0F);
		SetConsoleTextAttribute(hStdOut, wColor);
	}
	return;
}

void ClearColor() {
	SetColor(15);
}

void ClearConsoleToColors(int ForgC, int BackC)
{
	WORD wColor = ((BackC & 0x0F) << 4) + (ForgC & 0x0F);
	//Get the handle to the current output buffer...
	HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	//This is used to reset the carat/cursor to the top left.
	COORD coord = { 0, 0 };
	//A return value... indicating how many chars were written
	//   not used but we need to capture this since it will be
	//   written anyway (passing NULL causes an access violation).
	DWORD count;

	//This is a structure containing all of the console info
	// it is used here to find the size of the console.
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	//Here we will set the current color
	SetConsoleTextAttribute(hStdOut, wColor);
	if (GetConsoleScreenBufferInfo(hStdOut, &csbi))
	{
		//This fills the buffer with a given character (in this case 32=space).
		FillConsoleOutputCharacter(hStdOut, (TCHAR)32, csbi.dwSize.X * csbi.dwSize.Y, coord, &count);

		FillConsoleOutputAttribute(hStdOut, csbi.wAttributes, csbi.dwSize.X * csbi.dwSize.Y, coord, &count);
		//This will set our cursor position for the next print statement.
		SetConsoleCursorPosition(hStdOut, coord);
	}
	return;
}

void SetColorAndBackground(int ForgC, int BackC)
{
	WORD wColor = ((BackC & 0x0F) << 4) + (ForgC & 0x0F);;
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), wColor);
	return;
}

struct pscr
{
	int num;
	char snm[10];
	char nme[10];
	int mid;
	int fin;
	int hw1;
	int hw2;
	int atd;
};

typedef struct pscr pscr;

int grd(int);
char *gd[] = { "A+", "Ao", "B+", "Bo", "C+", "Co", "D+", "Do", "F" };
double ttp(pscr *);

pscr psc;

int main()
{
	//0:  1: Ķ 2:  3: ϴû 4:  5: ȫ 6 :  7: ȸ 
	//8: ȸ 9: Ķ 10: λ 11: ϴû 12:  13: ȫ 14 : 
	//15: 
	SetColor(0); 
	//SetColorAndBackground(15, 12);
	printf("===================================================================\n");
	printf("%40s\n", "ó α׷");
	printf("===================================================================\n\n");
	SetColor(9);

	FILE *fp, *fp2;
	char fn[] = "strscr.txt", fn2[] = "nlst.txt";
	pscr *pps = &psc;

	if ((fp = fopen(fn, "r")) == NULL)
	{
		printf("can't open the file\n");
		exit(1);
	}
	if ((fp2 = fopen(fn2, "w")) == NULL)
	{
		printf("can't open the file\n");
		exit(1);
	}

	while (!feof(fp))
	{
		fscanf(fp, "%d%s%s%d%d%d%d%d", &psc.num, psc.snm,
			psc.nme, &psc.mid, &psc.fin, &psc.hw1, &psc.hw2, &psc.atd);

		// 
		SetColor(9);
		printf("%3d%10s%10s%5d%5d%5d%5d%5d\n", pps->num,
			pps->snm, pps->nme, pps->mid, pps->fin, pps->hw1, pps->hw2, pps->atd);
		fprintf(fp2, "%3d%10s%10s%5d%5d%5d%5d%5d\n", pps->num,
			pps->snm, pps->nme, pps->mid, pps->fin, pps->hw1, pps->hw2, pps->atd);

		//ȯ 
		SetColor(8);
		printf("%28.1f %4.1f %4.1f %4.1f %4d %8.1f", pps->mid *0.3, pps->fin *0.4,
			pps->hw1 *0.3, pps->hw2 *0.3, pps->atd, ttp(pps));
		fprintf(fp2, "%28.1f %4.1f %4.1f %4.1f %4d %8.1f", pps->mid *0.3, pps->fin *0.4,
			pps->hw1 *0.3, pps->hw2 *0.3, pps->atd, ttp(pps));

		// 
		SetColor(13);
		printf("%8s", gd[grd((int)ttp(pps))]);
		fprintf(fp2, "%8s", gd[grd((int)ttp(pps))]);
		printf("\n\n"); fprintf(fp2, "\n\n");
	}

	fclose(fp);
	fclose(fp2);

	return 0;
}

double ttp(pscr *x)
{
	double y = (double)x->mid * 0.3 + x->fin * 0.4 + x->hw1 * 0.3 + x->hw2 * 0.3 + x->atd;
	return y;
}

int grd(int x)
{
	int y;

	if (x >= 95)
		y = 0;
	else if (x >= 90)
		y = 1;
	else if (x >= 85)
		y = 2;
	else if (x >= 80)
		y = 3;
	else if (x >= 75)
		y = 4;
	else if (x >= 70)
		y = 5;
	else if (x >= 65)
		y = 6;
	else if (x >= 60)
		y = 7;
	else if (x >= 0)
		y = 8;
	return y;
}
